.publish:
  image: curlimages/curl:latest
  variables:
    TERRAFORM_MODULE_DIR: ${CI_PROJECT_DIR} # The path to your Terraform module
    TERRAFORM_MODULE_NAME: ${CI_PROJECT_NAME} # The name of your Terraform module
    TERRAFORM_MODULE_SYSTEM: gitlab # The system or provider your Terraform module targets (ex. local, aws, google)
    TERRAFORM_MODULE_VERSION: ${CI_COMMIT_TAG} # The version of your Terraform module to be published to your project's registry
  script:
    - export TERRAFORM_MODULE_VERSION=$(echo ${CI_COMMIT_TAG} | awk -F- '{print $NF}')
    - tar -cvzf ${TERRAFORM_MODULE_NAME}-${TERRAFORM_MODULE_SYSTEM}-${TERRAFORM_MODULE_VERSION}.tgz -C ${TERRAFORM_MODULE_DIR}/${TERRAFORM_MODULE_NAME} --exclude=./.git .
    - 'curl -v --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file ${TERRAFORM_MODULE_NAME}-${TERRAFORM_MODULE_SYSTEM}-${TERRAFORM_MODULE_VERSION}.tgz ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/terraform/modules/${TERRAFORM_MODULE_NAME}/${TERRAFORM_MODULE_SYSTEM}/${TERRAFORM_MODULE_VERSION}/file'

external-access:publish:
  extends: .publish
  variables:
    TERRAFORM_MODULE_NAME: external_access
    TERRAFORM_MODULE_SYSTEM: aws
  rules:
    - if: '$CI_COMMIT_TAG =~ /^external-access-\d+\.\d+\.\d+$/'

vpc-peering:publish:
  extends: .publish
  variables:
    TERRAFORM_MODULE_NAME: vpc_peering
    TERRAFORM_MODULE_SYSTEM: aws
  rules:
    - if: '$CI_COMMIT_TAG =~ /^vpc-peering-\d+\.\d+\.\d+$/'

aws-budget:publish:
  extends: .publish
  variables:
    TERRAFORM_MODULE_NAME: aws_budget
    TERRAFORM_MODULE_SYSTEM: aws
  rules:
    - if: '$CI_COMMIT_TAG =~ /^aws-budget-\d+\.\d+\.\d+$/'

iam-switch-role:publish:
  extends: .publish
  variables:
    TERRAFORM_MODULE_NAME: iam_switch_role
    TERRAFORM_MODULE_SYSTEM: aws
  rules:
    - if: '$CI_COMMIT_TAG =~ /^iam-switch-role-\d+\.\d+\.\d+$/'
